"use strict";function _interopDefault(t){return t&&"object"==typeof t&&"default"in t?t.default:t}var _extends=require("./extends-4cd3b69b.js"),React=require("react"),React__default=_interopDefault(React),clsx=_interopDefault(require("clsx")),component=require("./component-a3554e7f.js"),events=require("./events-476f527a.js"),util=require("./util-0e249821.js"),cssClasses={ACTIVE:"mdc-slider--active",DISABLED:"mdc-slider--disabled",DISCRETE:"mdc-slider--discrete",FOCUS:"mdc-slider--focus",HAS_TRACK_MARKER:"mdc-slider--display-markers",IN_TRANSIT:"mdc-slider--in-transit",IS_DISCRETE:"mdc-slider--discrete"},strings={ARIA_DISABLED:"aria-disabled",ARIA_VALUEMAX:"aria-valuemax",ARIA_VALUEMIN:"aria-valuemin",ARIA_VALUENOW:"aria-valuenow",CHANGE_EVENT:"MDCSlider:change",INPUT_EVENT:"MDCSlider:input",LAST_TRACK_MARKER_SELECTOR:".mdc-slider__track-marker:last-child",PIN_VALUE_MARKER_SELECTOR:".mdc-slider__pin-value-marker",STEP_DATA_ATTR:"data-step",THUMB_CONTAINER_SELECTOR:".mdc-slider__thumb-container",TRACK_MARKER_CONTAINER_SELECTOR:".mdc-slider__track-marker-container",TRACK_SELECTOR:".mdc-slider__track"},numbers={PAGE_FACTOR:4},DOWN_EVENTS=["mousedown","pointerdown","touchstart"],UP_EVENTS=["mouseup","pointerup","touchend"],MOVE_EVENT_MAP={mousedown:"mousemove",pointerdown:"pointermove",touchstart:"touchmove"},KEY_IDS={ARROW_DOWN:"ArrowDown",ARROW_LEFT:"ArrowLeft",ARROW_RIGHT:"ArrowRight",ARROW_UP:"ArrowUp",END:"End",HOME:"Home",PAGE_DOWN:"PageDown",PAGE_UP:"PageUp"},MDCSliderFoundation=function(t){function e(r){var n=t.call(this,component.__assign({},e.defaultAdapter,r))||this;return n.savedTabIndex_=NaN,n.active_=!1,n.inTransit_=!1,n.isDiscrete_=!1,n.hasTrackMarker_=!1,n.handlingThumbTargetEvt_=!1,n.min_=0,n.max_=100,n.step_=0,n.value_=0,n.disabled_=!1,n.preventFocusState_=!1,n.thumbContainerPointerHandler_=function(){return n.handlingThumbTargetEvt_=!0},n.interactionStartHandler_=function(t){return n.handleDown_(t)},n.keydownHandler_=function(t){return n.handleKeydown_(t)},n.focusHandler_=function(){return n.handleFocus_()},n.blurHandler_=function(){return n.handleBlur_()},n.resizeHandler_=function(){return n.layout()},n}return component.__extends(e,t),Object.defineProperty(e,"cssClasses",{get:function(){return cssClasses},enumerable:!0,configurable:!0}),Object.defineProperty(e,"strings",{get:function(){return strings},enumerable:!0,configurable:!0}),Object.defineProperty(e,"numbers",{get:function(){return numbers},enumerable:!0,configurable:!0}),Object.defineProperty(e,"defaultAdapter",{get:function(){return{hasClass:function(){return!1},addClass:function(){},removeClass:function(){},getAttribute:function(){return null},setAttribute:function(){},removeAttribute:function(){},computeBoundingRect:function(){return{top:0,right:0,bottom:0,left:0,width:0,height:0}},getTabIndex:function(){return 0},registerInteractionHandler:function(){},deregisterInteractionHandler:function(){},registerThumbContainerInteractionHandler:function(){},deregisterThumbContainerInteractionHandler:function(){},registerBodyInteractionHandler:function(){},deregisterBodyInteractionHandler:function(){},registerResizeHandler:function(){},deregisterResizeHandler:function(){},notifyInput:function(){},notifyChange:function(){},setThumbContainerStyleProperty:function(){},setTrackStyleProperty:function(){},setMarkerValue:function(){},appendTrackMarkers:function(){},removeTrackMarkers:function(){},setLastTrackMarkersStyleProperty:function(){},isRTL:function(){return!1}}},enumerable:!0,configurable:!0}),e.prototype.init=function(){var t=this;this.isDiscrete_=this.adapter_.hasClass(cssClasses.IS_DISCRETE),this.hasTrackMarker_=this.adapter_.hasClass(cssClasses.HAS_TRACK_MARKER),DOWN_EVENTS.forEach(function(e){t.adapter_.registerInteractionHandler(e,t.interactionStartHandler_),t.adapter_.registerThumbContainerInteractionHandler(e,t.thumbContainerPointerHandler_)}),this.adapter_.registerInteractionHandler("keydown",this.keydownHandler_),this.adapter_.registerInteractionHandler("focus",this.focusHandler_),this.adapter_.registerInteractionHandler("blur",this.blurHandler_),this.adapter_.registerResizeHandler(this.resizeHandler_),this.layout(),this.isDiscrete_&&0===this.getStep()&&(this.step_=1)},e.prototype.destroy=function(){var t=this;DOWN_EVENTS.forEach(function(e){t.adapter_.deregisterInteractionHandler(e,t.interactionStartHandler_),t.adapter_.deregisterThumbContainerInteractionHandler(e,t.thumbContainerPointerHandler_)}),this.adapter_.deregisterInteractionHandler("keydown",this.keydownHandler_),this.adapter_.deregisterInteractionHandler("focus",this.focusHandler_),this.adapter_.deregisterInteractionHandler("blur",this.blurHandler_),this.adapter_.deregisterResizeHandler(this.resizeHandler_)},e.prototype.setupTrackMarker=function(){if(this.isDiscrete_&&this.hasTrackMarker_&&0!==this.getStep()){var t=this.getMin(),e=this.getMax(),r=this.getStep(),n=(e-t)/r,i=Math.ceil(n)!==n;if(i&&(n=Math.ceil(n)),this.adapter_.removeTrackMarkers(),this.adapter_.appendTrackMarkers(n),i){var a=(e-n*r)/r+1;this.adapter_.setLastTrackMarkersStyleProperty("flex-grow",String(a))}}},e.prototype.layout=function(){this.rect_=this.adapter_.computeBoundingRect(),this.updateUIForCurrentValue_()},e.prototype.getValue=function(){return this.value_},e.prototype.setValue=function(t){this.setValue_(t,!1)},e.prototype.getMax=function(){return this.max_},e.prototype.setMax=function(t){if(t<this.min_)throw new Error("Cannot set max to be less than the slider's minimum value");this.max_=t,this.setValue_(this.value_,!1,!0),this.adapter_.setAttribute(strings.ARIA_VALUEMAX,String(this.max_)),this.setupTrackMarker()},e.prototype.getMin=function(){return this.min_},e.prototype.setMin=function(t){if(t>this.max_)throw new Error("Cannot set min to be greater than the slider's maximum value");this.min_=t,this.setValue_(this.value_,!1,!0),this.adapter_.setAttribute(strings.ARIA_VALUEMIN,String(this.min_)),this.setupTrackMarker()},e.prototype.getStep=function(){return this.step_},e.prototype.setStep=function(t){if(t<0)throw new Error("Step cannot be set to a negative number");this.isDiscrete_&&("number"!=typeof t||t<1)&&(t=1),this.step_=t,this.setValue_(this.value_,!1,!0),this.setupTrackMarker()},e.prototype.isDisabled=function(){return this.disabled_},e.prototype.setDisabled=function(t){this.disabled_=t,this.toggleClass_(cssClasses.DISABLED,this.disabled_),this.disabled_?(this.savedTabIndex_=this.adapter_.getTabIndex(),this.adapter_.setAttribute(strings.ARIA_DISABLED,"true"),this.adapter_.removeAttribute("tabindex")):(this.adapter_.removeAttribute(strings.ARIA_DISABLED),isNaN(this.savedTabIndex_)||this.adapter_.setAttribute("tabindex",String(this.savedTabIndex_)))},e.prototype.handleDown_=function(t){var e=this;if(!this.disabled_){this.preventFocusState_=!0,this.setInTransit_(!this.handlingThumbTargetEvt_),this.handlingThumbTargetEvt_=!1,this.setActive_(!0);var r=function(t){e.handleMove_(t)},n=MOVE_EVENT_MAP[t.type],i=function(){e.handleUp_(),e.adapter_.deregisterBodyInteractionHandler(n,r),UP_EVENTS.forEach(function(t){return e.adapter_.deregisterBodyInteractionHandler(t,i)})};this.adapter_.registerBodyInteractionHandler(n,r),UP_EVENTS.forEach(function(t){return e.adapter_.registerBodyInteractionHandler(t,i)}),this.setValueFromEvt_(t)}},e.prototype.handleMove_=function(t){t.preventDefault(),this.setValueFromEvt_(t)},e.prototype.handleUp_=function(){this.setActive_(!1),this.adapter_.notifyChange()},e.prototype.getPageX_=function(t){return t.targetTouches&&t.targetTouches.length>0?t.targetTouches[0].pageX:t.pageX},e.prototype.setValueFromEvt_=function(t){var e=this.getPageX_(t),r=this.computeValueFromPageX_(e);this.setValue_(r,!0)},e.prototype.computeValueFromPageX_=function(t){var e=this.max_,r=this.min_,n=(t-this.rect_.left)/this.rect_.width;return this.adapter_.isRTL()&&(n=1-n),r+n*(e-r)},e.prototype.handleKeydown_=function(t){var e=this.getKeyId_(t),r=this.getValueForKeyId_(e);isNaN(r)||(t.preventDefault(),this.adapter_.addClass(cssClasses.FOCUS),this.setValue_(r,!0),this.adapter_.notifyChange())},e.prototype.getKeyId_=function(t){return t.key===KEY_IDS.ARROW_LEFT||37===t.keyCode?KEY_IDS.ARROW_LEFT:t.key===KEY_IDS.ARROW_RIGHT||39===t.keyCode?KEY_IDS.ARROW_RIGHT:t.key===KEY_IDS.ARROW_UP||38===t.keyCode?KEY_IDS.ARROW_UP:t.key===KEY_IDS.ARROW_DOWN||40===t.keyCode?KEY_IDS.ARROW_DOWN:t.key===KEY_IDS.HOME||36===t.keyCode?KEY_IDS.HOME:t.key===KEY_IDS.END||35===t.keyCode?KEY_IDS.END:t.key===KEY_IDS.PAGE_UP||33===t.keyCode?KEY_IDS.PAGE_UP:t.key===KEY_IDS.PAGE_DOWN||34===t.keyCode?KEY_IDS.PAGE_DOWN:""},e.prototype.getValueForKeyId_=function(t){var e=this.max_,r=this.min_,n=this.step_||(e-r)/100;switch(this.adapter_.isRTL()&&(t===KEY_IDS.ARROW_LEFT||t===KEY_IDS.ARROW_RIGHT)&&(n=-n),t){case KEY_IDS.ARROW_LEFT:case KEY_IDS.ARROW_DOWN:return this.value_-n;case KEY_IDS.ARROW_RIGHT:case KEY_IDS.ARROW_UP:return this.value_+n;case KEY_IDS.HOME:return this.min_;case KEY_IDS.END:return this.max_;case KEY_IDS.PAGE_UP:return this.value_+n*numbers.PAGE_FACTOR;case KEY_IDS.PAGE_DOWN:return this.value_-n*numbers.PAGE_FACTOR;default:return NaN}},e.prototype.handleFocus_=function(){this.preventFocusState_||this.adapter_.addClass(cssClasses.FOCUS)},e.prototype.handleBlur_=function(){this.preventFocusState_=!1,this.adapter_.removeClass(cssClasses.FOCUS)},e.prototype.setValue_=function(t,e,r){if(void 0===r&&(r=!1),t!==this.value_||r){var n=this.min_,i=this.max_,a=t===n||t===i;this.step_&&!a&&(t=this.quantize_(t)),t<n?t=n:t>i&&(t=i),this.value_=t,this.adapter_.setAttribute(strings.ARIA_VALUENOW,String(this.value_)),this.updateUIForCurrentValue_(),e&&(this.adapter_.notifyInput(),this.isDiscrete_&&this.adapter_.setMarkerValue(t))}},e.prototype.quantize_=function(t){return Math.round(t/this.step_)*this.step_},e.prototype.updateUIForCurrentValue_=function(){var t=this,e=this.max_,r=this.min_,n=(this.value_-r)/(e-r),i=n*this.rect_.width;this.adapter_.isRTL()&&(i=this.rect_.width-i);var a=util.getCorrectPropertyName(window,"transform"),s=util.getCorrectEventName(window,"transitionend");if(this.inTransit_){var o=function(){t.setInTransit_(!1),t.adapter_.deregisterThumbContainerInteractionHandler(s,o)};this.adapter_.registerThumbContainerInteractionHandler(s,o)}requestAnimationFrame(function(){t.adapter_.setThumbContainerStyleProperty(a,"translateX("+i+"px) translateX(-50%)"),t.adapter_.setTrackStyleProperty(a,"scaleX("+n+")")})},e.prototype.setActive_=function(t){this.active_=t,this.toggleClass_(cssClasses.ACTIVE,this.active_)},e.prototype.setInTransit_=function(t){this.inTransit_=t,this.toggleClass_(cssClasses.IN_TRANSIT,this.inTransit_)},e.prototype.toggleClass_=function(t,e){e?this.adapter_.addClass(t):this.adapter_.removeClass(t)},e}(component.MDCFoundation),MDCSlider=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return component.__extends(e,t),e.attachTo=function(t){return new e(t)},Object.defineProperty(e.prototype,"value",{get:function(){return this.foundation_.getValue()},set:function(t){this.foundation_.setValue(t)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"min",{get:function(){return this.foundation_.getMin()},set:function(t){this.foundation_.setMin(t)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"max",{get:function(){return this.foundation_.getMax()},set:function(t){this.foundation_.setMax(t)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"step",{get:function(){return this.foundation_.getStep()},set:function(t){this.foundation_.setStep(t)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"disabled",{get:function(){return this.foundation_.isDisabled()},set:function(t){this.foundation_.setDisabled(t)},enumerable:!0,configurable:!0}),e.prototype.initialize=function(){this.thumbContainer_=this.root_.querySelector(strings.THUMB_CONTAINER_SELECTOR),this.track_=this.root_.querySelector(strings.TRACK_SELECTOR),this.pinValueMarker_=this.root_.querySelector(strings.PIN_VALUE_MARKER_SELECTOR),this.trackMarkerContainer_=this.root_.querySelector(strings.TRACK_MARKER_CONTAINER_SELECTOR)},e.prototype.getDefaultFoundation=function(){var t=this;return new MDCSliderFoundation({hasClass:function(e){return t.root_.classList.contains(e)},addClass:function(e){return t.root_.classList.add(e)},removeClass:function(e){return t.root_.classList.remove(e)},getAttribute:function(e){return t.root_.getAttribute(e)},setAttribute:function(e,r){return t.root_.setAttribute(e,r)},removeAttribute:function(e){return t.root_.removeAttribute(e)},computeBoundingRect:function(){return t.root_.getBoundingClientRect()},getTabIndex:function(){return t.root_.tabIndex},registerInteractionHandler:function(e,r){return t.listen(e,r,events.applyPassive())},deregisterInteractionHandler:function(e,r){return t.unlisten(e,r,events.applyPassive())},registerThumbContainerInteractionHandler:function(e,r){t.thumbContainer_.addEventListener(e,r,events.applyPassive())},deregisterThumbContainerInteractionHandler:function(e,r){t.thumbContainer_.removeEventListener(e,r,events.applyPassive())},registerBodyInteractionHandler:function(t,e){return document.body.addEventListener(t,e)},deregisterBodyInteractionHandler:function(t,e){return document.body.removeEventListener(t,e)},registerResizeHandler:function(t){return window.addEventListener("resize",t)},deregisterResizeHandler:function(t){return window.removeEventListener("resize",t)},notifyInput:function(){return t.emit(strings.INPUT_EVENT,t)},notifyChange:function(){return t.emit(strings.CHANGE_EVENT,t)},setThumbContainerStyleProperty:function(e,r){t.thumbContainer_.style.setProperty(e,r)},setTrackStyleProperty:function(e,r){return t.track_.style.setProperty(e,r)},setMarkerValue:function(e){return t.pinValueMarker_.innerText=e.toLocaleString()},appendTrackMarkers:function(e){for(var r=document.createDocumentFragment(),n=0;n<e;n++){var i=document.createElement("div");i.classList.add("mdc-slider__track-marker"),r.appendChild(i)}t.trackMarkerContainer_.appendChild(r)},removeTrackMarkers:function(){for(;t.trackMarkerContainer_.firstChild;)t.trackMarkerContainer_.removeChild(t.trackMarkerContainer_.firstChild)},setLastTrackMarkersStyleProperty:function(e,r){t.root_.querySelector(strings.LAST_TRACK_MARKER_SELECTOR).style.setProperty(e,r)},isRTL:function(){return"rtl"===getComputedStyle(t.root_).direction}})},e.prototype.initialSyncWithDOM=function(){var t=this.parseFloat_(this.root_.getAttribute(strings.ARIA_VALUENOW),this.value),e=this.parseFloat_(this.root_.getAttribute(strings.ARIA_VALUEMIN),this.min),r=this.parseFloat_(this.root_.getAttribute(strings.ARIA_VALUEMAX),this.max);e>=this.max?(this.max=r,this.min=e):(this.min=e,this.max=r),this.step=this.parseFloat_(this.root_.getAttribute(strings.STEP_DATA_ATTR),this.step),this.value=t,this.disabled=this.root_.hasAttribute(strings.ARIA_DISABLED)&&"false"!==this.root_.getAttribute(strings.ARIA_DISABLED),this.foundation_.setupTrackMarker()},e.prototype.layout=function(){this.foundation_.layout()},e.prototype.stepUp=function(t){void 0===t&&(t=this.step||1),this.value+=t},e.prototype.stepDown=function(t){void 0===t&&(t=this.step||1),this.value-=t},e.prototype.parseFloat_=function(t,e){var r=parseFloat(t);return"number"==typeof r&&isFinite(r)?r:e},e}(component.MDCComponent),Slider=function(t){var e=t.label,r=void 0===e?"":e,n=t.discrete,i=void 0!==n&&n,a=t.min,s=void 0===a?0:a,o=t.max,u=void 0===o?100:o,_=t.value,d=void 0===_?0:_,c=t.tabIndex,l=void 0===c?0:c,h=t.step,p=void 0===h?null:h,f=t.markers,m=void 0!==f&&f,E=t.disabled,g=void 0!==E&&E,A=t.onChange,y=void 0===A?function(){}:A,v=React.useRef();React.useEffect(function(){var t=new MDCSlider(v.current);t.listen("MDCSlider:change",function(){return y(t.value)})},[]);var R=clsx("mdc-slider",{"mdc-slider--discrete":i},{"mdc-slider--display-markers":m});return React__default.createElement("div",_extends._extends({ref:v,className:R,tabIndex:l,role:"slider","aria-valuemin":s,"aria-valuemax":u,"aria-valuenow":d,"aria-disabled":g?"true":null},p?{"data-step":p}:{},r?{"aria-label":r}:{}),React__default.createElement("div",{className:"mdc-slider__track-container"},React__default.createElement("div",{className:"mdc-slider__track"}),m&&i?React__default.createElement("div",{className:"mdc-slider__track-marker-container"}):""),React__default.createElement("div",{className:"mdc-slider__thumb-container"},i?React__default.createElement("div",{className:"mdc-slider__pin"},React__default.createElement("span",{className:"mdc-slider__pin-value-marker"})):"",React__default.createElement("svg",{className:"mdc-slider__thumb",width:"21",height:"21"},React__default.createElement("circle",{cx:"10.5",cy:"10.5",r:"7.875"})),React__default.createElement("div",{className:"mdc-slider__focus-ring"})))};module.exports=Slider;
